/* ===========================================================================
                         PRODUCT OF MATRICES
It would have been good if C++ had a polymorphic type discipline, and
C++ would have accepted a type declaration of the form: int A[n][m],
where n and m are two integer variables whose values are known at run time.
=========================================================================== */
#include <iostream.h>
const int n=2; const int m=3; const int k=2;
int A[n][m]; int B[m][k]; int C[n][k];
/*--------------------------------------------------------------------------
We cannot have readmat(int A[][], int n, int m), so we have to consider arrays
as pointers and write readmat(int* A, int n, int m). In the matrix A[n][m]
(n rows: 0..n-1, and m columns: 0..m-1) the element A[i,j] is *(A+i*m+j).
// ------------------------------------------------------------------------*/
void readmat(int* A, int n, int m)
{for (int i=0; i<n; i++) {for (int j=0; j<m; j++) {cin >> *(A+i*m+j);}}}

void writemat(int* A, int n, int m)
{for (int i=0; i<n; i++)
      {for (int j=0; j<m; j++) {cout << *(A+i*m+j) << " ";}; cout <<"\n";}}
// ---------------------------------------------------------------------------
void main()
{cout << "n="<<n<<",  m="<<m<<",  k="<<k<<".\n";
cout << "Write "<<n<<"x"<<m
     <<"integers and CR. The matrix A will be created.\n";
readmat((int*)A,n,m); cout << "Matrix A in input:\n";
writemat((int*)A,n,m);
cout << "Write "<<m
     << "x"<<k<<" integers and CR. The matrix B will be created.\n";
readmat((int*)B,m,k); cout << "Matrix B in input:\n";
writemat((int*)B,m,k);
for (int i=0; i<n; i++)
{for (int j=0; j<k; j++)
{*((int*)C+i*k+j)=0;
 for (int h=0; h<m; h++) {C[i][j]=C[i][j]+A[i][h]*B[h][j];};};};
// one can write: C[i][j] = C[i][j]+A[i][h]*B[h][j];
// as:   *((int*)C+i*k+j) = *((int*)C+i*k+j) +
//                          *((int*)A+i*m+h) * *((int*)B+h*k+j);
cout << "Product matrix C=AxB:\n"; writemat((int*)C,n,k);}
/* input:                  output:
------------------------------------------------------------------------------
                       n=2,  m=3,  k=2.
                       Write 2x3 integers and CR. A matrix will be created.
      1 2 3 4 5 6 CR
                       Matrix A in input:
                       1 2 3
                       4 5 6
                       Write 3x2 integers and CR. A matrix will be created.
      1 2 3 4 5 6 CR
                       Matrix B in input:
                       1 2
                       3 4
                       5 6
                       Product matrix C=AxB:
                       22  28
                       49  64
--------------------------------------------------------------------------- */